%define name	qemu
%define version	0.5.0
%define release	4mdk

%define __find_requires %{_builddir}/%{name}-%{version}/find_requires.sh

Summary:	QEMU CPU Emulator
Name:		%{name}
Version:	%{version}
Release:	%{release}
Source0:	%{name}-%{version}.tar.bz2
Patch0:		qemu-0.5.0-cvsupdates.patch.bz2
Patch1:		qemu-0.1.6-glibc23-ldscripts.patch.bz2
Patch2:		qemu-0.5.0-sdl-static-libs.patch.bz2
Patch3:		qemu-0.5.0-DESTDIR.patch.bz2
Patch4:		qemu-0.5.0-lib64.patch.bz2
Patch5:		qemu-0.5.0-amd64.patch.bz2
Patch6:		qemu-0.5.0-vl-amd64.patch.bz2
License:	GPL
URL:		http://fabrice.bellard.free.fr/qemu/
Group:		Emulators
BuildRequires:	glibc-static-devel XFree86-devel
BuildRequires:	SDL1.2-devel, libalsa-static-devel, libnas-static-devel
ExclusiveArch:	%{ix86} ppc x86_64 amd64
BuildRequires:	tetex-texi2html
#Requires:	x86-compat-libs
BuildRoot:	%{_tmppath}/%{name}-buildroot

%description
QEMU is a FAST! processor emulator. By using dynamic translation it
achieves a reasonnable speed while being easy to port on new host
CPUs. QEMU has two operating modes:

* User mode emulation. In this mode, QEMU can launch Linux processes
  compiled for one CPU on another CPU. Linux system calls are
  converted because of endianness and 32/64 bit mismatches. Wine
  (Windows emulation) and DOSEMU (DOS emulation) are the main targets
  for QEMU.

* Full system emulation. In this mode, QEMU emulates a full system,
  including a processor and various peripherials. Currently, it is
  only used to launch an x86 Linux kernel on an x86 Linux system. It
  enables easier testing and debugging of system code. It can also be
  used to provide virtual hosting of several virtual PC on a single
  server.

%prep
%setup -q
%patch0 -p1 -b .cvsupdates
%patch1 -p1 -b .glibc23-ldscripts
%patch2 -p1 -b .sdl-static-libs
%patch3 -p1 -b .DESTDIR
%patch4 -p1 -b .lib64
%patch5 -p1 -b .amd64
# needs to 64-bit clean softmmu code or MAP_32BIT physical_ram_base
# but other problems remain.
#%patch6 -p1 -b .vl-amd64

%build
./configure --prefix=%{_prefix}
%make

%install
rm -rf $RPM_BUILD_ROOT

%makeinstall_std

# nuke explicit dependencies on GLIBC_PRIVATE
cat >find_requires.sh << EOF
#!/bin/sh
%{_prefix}/lib/rpm/find-requires %{buildroot} %{_target_cpu} | grep -v GLIBC_PRIVATE
EOF
chmod +x find_requires.sh

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc README qemu-doc.html
%ifarch %{ix86}
%{_bindir}/qemu-fast
%endif
%ifarch %{ix86} ppc
%{_bindir}/qemu
%endif
%{_bindir}/qemu-mkcow
%{_bindir}/qemu-arm
%{_bindir}/qemu-i386
%{_bindir}/qemu-sparc
%{_mandir}/man1/qemu.1*
%dir %{_datadir}/qemu
%{_datadir}/qemu/bios.bin
%{_datadir}/qemu/vgabios.bin

%changelog
* Tue Mar 02 2004 Per yvind Karlsen <peroyvind@linux-mandrake.com> 0.5.0-4mdk
- buildrequires

* Fri Nov  7 2003 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.5.0-3mdk
- lib64 fixes
- update to current CVS:
  - float access fixes when using soft mmu
  - PC emulation support on PowerPC
  - A20 support

* Thu Nov  6 2003 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.5.0-2mdk
- add initial AMD64 host cpu support

* Thu Nov  6 2003 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.5.0-1mdk
- 0.5.0

* Fri Aug 01 2003 Michael Scherer <scherer.michael@free.fr> 0.4.1-2mdk
- BuildRequires ( glibc-static-devel ) 

* Mon Jul  7 2003 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.4.1-1mdk
- 0.4.1

* Tue Jun  3 2003 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.2-1mdk
- 0.2

* Sat Apr 12 2003 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.1.6-1mdk
- 0.1.6

* Mon Mar 31 2003 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.1.4-1mdk
- 0.1.4

* Thu Mar 27 2003 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.1.2-1mdk
- First Mandrake Linux package
- Patch0: Fix x86 signal handler to retrieve pc from [REG_IP] slot
- Patch1: Add support for nanosecond resolution timestamps from glibc 2.3
- Patch2: Adjust ldscripts for glibc >= 2.3
- Patch3: Handle exit_group syscall as an exit
- Patch4: Add missing includes
